﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Data.SqlClient;

namespace ToolSystem
{
    public class Tool
    {

        public int ToolId { get; set; }
        public string ToolName { get; set; }
        public string ToolTag { get; set; }
        public string ToolDescription { get; set; }
        public int ToolInUse { get; set; }


        public string GetToolName(string connectionString, int toolId)
        {
            string toolName = "";

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select ToolName from TOOL where ToolId = " + toolId;
            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();


            if (dr != null)
            {
                while (dr.Read())
                {
                    toolName = dr["ToolName"].ToString();
                }
            }

            return toolName;

        }

        public List<Tool> GetTools(string connectionString)
        {

            List<Tool> toolList = new List<Tool>();

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select ToolId, ToolName, ToolTag, ToolDescription, ToolInUse from TOOL";

            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            if (dr != null)
            {
                while (dr.Read())
                {
                    Tool tool = new Tool();

                    tool.ToolId = Convert.ToInt32(dr["ToolId"]);
                    tool.ToolName = dr["ToolName"].ToString();
                    tool.ToolTag = dr["ToolTag"].ToString();
                    tool.ToolDescription = dr["ToolDescription"].ToString();
                    tool.ToolInUse = Convert.ToInt32(dr["ToolInUse"]);

                    toolList.Add(tool);
                }

            }

            return toolList;
        }

        public void NewTool(string connectionString, Tool tool)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("NewTool", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@ToolName", tool.ToolName));
                    cmd.Parameters.Add(new SqlParameter("@ToolTag", tool.ToolTag));
                    cmd.Parameters.Add(new SqlParameter("@ToolDescription", tool.ToolDescription));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw;
            }

        }

        public Tool GetToolData(string connectionString, int toolId)
        {

            SqlConnection con = new SqlConnection(connectionString);

            string selectSQL = "select ToolId, ToolName, ToolTag, ToolDescription  from TOOL where ToolId = " + toolId;
            con.Open();

            SqlCommand cmd = new SqlCommand(selectSQL, con);

            SqlDataReader dr = cmd.ExecuteReader();

            Tool tool = new Tool();

            if (dr != null)
            {
                while (dr.Read())
                {
                    tool.ToolId = Convert.ToInt32(dr["ToolId"]);
                    tool.ToolName = dr["ToolName"].ToString();
                    tool.ToolTag = dr["ToolTag"].ToString();
                    tool.ToolDescription = dr["ToolDescription"].ToString();
                }
            }

            return tool;
        }

        public void EditTool(string connectionString, Tool tool)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("UpdateTool", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@ToolId", tool.ToolId));
                    cmd.Parameters.Add(new SqlParameter("@ToolName", tool.ToolName));
                    cmd.Parameters.Add(new SqlParameter("@ToolTag", tool.ToolTag));
                    cmd.Parameters.Add(new SqlParameter("@ToolDescription", tool.ToolDescription));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw;
            }

        }

        public void DeleteTool(string connectionString, int toolId)
        {
            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("DeleteTool", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@ToolId", toolId));


                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw;
            }

        }

        public void BorrowTool(string connectionString, string PersonTag, string ToolTag)
        {

            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("BorrowTool", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@PersonTag", PersonTag));
                    cmd.Parameters.Add(new SqlParameter("@ToolTag", ToolTag));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw;
            }


        }

        public void BorrowToolById(string connectionString, int userId, int toolId)
        {

            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("BorrowToolById", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@PersonId", userId));
                    cmd.Parameters.Add(new SqlParameter("@ToolId", toolId));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw;
            }


        }

        public void ReturnTool(string connectionString, string ToolTag)
        {

            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("ReturnTool", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@ToolTag", ToolTag));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw;
            }


        }


        public void ReturnToolById(string connectionString, int toolId)
        {

            try
            {
                using (SqlConnection con = new SqlConnection(connectionString))
                {
                    SqlCommand cmd = new SqlCommand("ReturnToolById", con);
                    cmd.CommandType = CommandType.StoredProcedure;

                    cmd.Parameters.Add(new SqlParameter("@ToolId", toolId));

                    con.Open();
                    cmd.ExecuteNonQuery();
                    con.Close();
                }

            }
            catch (Exception ex)
            {
                throw;
            }


        }
    }
}
