using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Identity;
using ToolSystem;


namespace Tool_Management.Pages
{
    public class NewPersonModel : PageModel
    {
        readonly IConfiguration _configuration;

        public string connectionString;

        public NewPersonModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }
        public void OnGet()
        {
        }

        public void OnPost()
        {
            Person person = new Person();

            person.PersonName = Request.Form["PersonName"];
            person.PersonTag = Request.Form["PersonTag"];
            person.EMail = Request.Form["EMail"];

            person.Password = PasswordHash(person.EMail, person.PersonTag);

            connectionString = _configuration.GetConnectionString("ConnectionString");

            person.NewPerson(connectionString, person);

            Response.Redirect("./PersonList");
        }


        string PasswordHash(string userName, string password)
        {

            PasswordHasher<string> pw = new PasswordHasher<string>();

            string passwordHashed = pw.HashPassword(userName, password);

            return passwordHashed;

        }
    }
}
