using System;
using System.Collections.Generic;
using Microsoft.AspNetCore.Identity;
using Microsoft.Extensions.Configuration;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.AspNetCore.Http;
using ToolSystem;

namespace LoginApp.Pages
{
    public class UpdateUserModel : PageModel
    {
        readonly IConfiguration _configuration;

        private string connectionString;

        public string userName = null;
        public int validUser = 0;

        public Login loginuserDB = new Login();

        public UpdateUserModel(IConfiguration configuration)
        {
            _configuration = configuration;
        }

        public void OnGet()
        {
            VerifyLogin();

            GetUserInformation();
        }

        public void OnPost()
        {
            VerifyLogin();

            UpdateUser();
        }

        void GetUserInformation()
        {
            Login loginuser = new Login();

            connectionString = _configuration.GetConnectionString("ConnectionString");

            int personId = 6; //Kode m oppdateres!!!

            loginuserDB = loginuser.GetLoginUserData(connectionString, personId);

        }

        void VerifyLogin()
        {
            if (HttpContext.Session.GetInt32("Login") != null)
                validUser = (int)HttpContext.Session.GetInt32("Login");
            else
            { 
                validUser = 0;
                Response.Redirect("./Error");
            }

            if (HttpContext.Session.GetString("UserName") != null)
                userName = HttpContext.Session.GetString("UserName");
            else
                userName = null;
        }


        void UpdateUser()
        {
            Login loginuser = new Login();
            string userName;
            string password;

            connectionString = _configuration.GetConnectionString("ConnectionString");

            loginuser.PersonId = Convert.ToInt32(Request.Form["PersonId"]);
            loginuser.PersonName = Request.Form["FullName"];
            loginuser.EMail = Request.Form["EMail"];
            loginuser.Password = Request.Form["Password"];
            loginuser.Password = PasswordHash(loginuser.EMail, loginuser.Password);

            loginuser.UpdateLoginUser(connectionString, loginuser);

            Response.Redirect("./User");
        }


        string PasswordHash(string userName, string password)
        {

            PasswordHasher<string> pw = new PasswordHasher<string>();

            string passwordHashed = pw.HashPassword(userName, password);

            return passwordHashed;

        }

    }
}
