IF EXISTS (SELECT name 
	   FROM   sysobjects 
	   WHERE  name = 'SetToolStatus' 
	   AND 	  type = 'P')
	DROP PROCEDURE SetToolStatus
GO

CREATE PROCEDURE SetToolStatus
@PersonTag varchar(100),
@ToolTag varchar(100)
AS

DECLARE
@PersonId int,
@ToolInUse int

SELECT @PersonId = PersonId FROM PERSON WHERE PersonTag = @PersonTag

SELECT @ToolInUse = ToolInUse FROM TOOL WHERE ToolTag = @ToolTag

IF @ToolInUse=1
	BEGIN
		SET @ToolInUse=0
		UPDATE TOOL SET
		ToolInUse = @ToolInUse,
		PersonId = NULL,
		RentDate = NULL
		WHERE ToolTag = @ToolTag
	END
ELSE
	BEGIN
		SET @ToolInUse=1
		UPDATE TOOL SET
		ToolInUse = @ToolInUse,
		PersonId = @PersonId,
		RentDate = getdate()
		WHERE ToolTag = @ToolTag
	END

GO